
#load'C:\Users\Keith\Documents\ShopProjects\TestPlugins\BoardToLayer.rb'

# Name :          comptolayer  ###
# Date :	     9 10 2010
# Description :   

# Author :       Keith Krueger (with a big help from plugin forum:)
#    
require 'sketchup.rb'


def Board_to_layer()
      model=Sketchup.active_model
      layers = model.layers
      ss=model.selection
      entity = ss.first
      pages = model.pages
      count = pages.count
      length = layers.length     
      definitions = model.definitions
      
      #Initialize Variables
      userLName = []
      cName = []
      userCName = []
      
      # Check to see if component selected
      if ss[0].class != Sketchup::ComponentInstance
        UI.messagebox("Select a Component to Name a Layer after...")
        return nil
      end#if
      #cName=nil
      cName=ss[0].definition.name
      if not cName or cName==""
        UI.messagebox("Select a NAMED Component to Name a Layer after...")
        return nil
      end#if
      
      #Component Name Input Box
      userCName = nil
      loop do
      componentnameunique = ""
      # Component Name Input Box
      prompts = [$exStrings.GetString("Component Name")]
      values = [cName]
          
      # Now display the inputbox
      results = inputbox prompts, values, $exStrings.GetString("Component New Name")
            
      return if not results # This means that the user canceld the operation
    
      userCName = results[0]

      #UI.messagebox ("User entered .. " + userCName + "  .. for Component Name")# Debug

      if userCName ==  cName
        #UI.messagebox "Insert input loop break and keep existing component name"# Debug
        break
      end#if

      componentdefinition = definitions[userCName]

      #UI.messagebox ("test variable " + componentdefinition.to_s.length.to_s)# Debug
      #UI.messagebox ("compared to " + componentnameunique.length.to_s )# Debug

      componentnameunique = componentdefinition.to_s.length > componentnameunique.length ?  "no" :  "yes"
      if componentnameunique == "yes"
         #UI.messagebox "Insert input loop break component name was unique"# Debug
         break
      else
         UI.messagebox ("Component name .. " + userCName + "  ..  not unique enter new name")
      end#if

      end#loop
      # Change Component Name
      if  userCName !=  cName
        ss[0].definition.name=userCName
        cName=ss[0].definition.name
        if cName!=userCName
          UI.messagebox("Caution SketchUP added #No to make Name Unique")
        end #if
      end#if                                    

#UI.messagebox "Change Component Name & Program continues to change layer"

#userCName = "board"#Debug
      # Layer Name Input Box
      loop do
      prompts = [$exStrings.GetString("Layer Name")]
      values = [userCName]

      # Now display the inputbox
      results = inputbox prompts, values, $exStrings.GetString(" New Layer Name")

      return if not results # This means that the user canceld the operation

      userLName = results[0]

      #UI.messagebox ("User entered .. " + userLName + "  .. for Layer Name")# Debug

      # Test to see if layer name already exists
      lnameexist = "no"
      layers.each {|l|
      layername = l.name
      lnameexist = layername == userLName ?  "yes" :  lnameexist }
      #UI.messagebox ("Layer name exists ?  " + lnameexist)# Debug
        if lnameexist ==  "no"
          # Create new layer for Component 
          layer = layers.add userLName
          pb = layer.page_behavior = LAYER_IS_HIDDEN_ON_NEW_PAGES
          model.pages.each { |p| p.set_visibility( layer, false ) }
          # Place Component on Layer    
          entity.layer=(layers[userLName])
          break# Exit input loop
        else
          results = UI.messagebox "Yes - Use Exiting Layer; No - Change Layer name", MB_YESNO
          #UI.messagebox ("results = " + results.to_s)#Debug
          if results ==  IDYES
            # Place Component on Layer
            entity.layer=(layers[userLName])
            break# Exit input loop
          end#if
        end#if
      end#Layer Input Loop
      
      
      # Add page named Assembly if not already added
      pagename=[]
      pgAssy = "no"
	    pages.each {|p|
      pagename = p.name
      if pagename == "Assembly"
        pgAssy = "yes"
      end }#if and each loop
      
      if pgAssy == "no"
        pages.add "Assembly"
      end#if
      
    # Make New Part Component visible on "Assembly" Page   

      page = pages["Assembly"]
      page.set_visibility(layers [userLName] ,true)


      
                
end#def


if(not file_loaded?("BoardToLayer.rb")) 
ss=Sketchup.active_model.selection
  UI.add_context_menu_handler do |menu|
    menu.add_separator if ss[0].class ==Sketchup::ComponentInstance
   menu.add_item("Board/Comp to New layer"){Board_to_layer()}if ss[0].class==Sketchup::ComponentInstance
  end
end
file_loaded ("BoardToLayer.rb")
